<template>
  <div div="user">
    <b-jumbotron>
      <template
        slot="header"
      >Student {{ $route.params.studentName }} of {{ $route.params.groupName }}</template>

      <div>
        <b-alert :show="hasError" dismissible variant="danger">{{ alertMessage }}</b-alert>
      </div>

      <div>Student {{ student.name + ' ' + student.surname }}, from group {{ student.group }}, department of {{ student.department }}</div>
      <div class="mydiv-tablealign">
      <table class="table table-bordered">
      <thead>
        <tr>
          <th>Subject mame</th>
          <th>Subject date</th>
          <th>Exam</th>
          <th>Mark</th>
          <th>Attempts</th>
          <th>Passed</th>
        </tr>
      </thead>

      <tr v-for="subject in student.subjects" class="static" v-bind:key="subject">
        <td>{{subject.name}}</td>
        <td>{{subject.year}}/{{subject.month}}</td>
        <td>{{subject.hasExam ? '+' : ''}}</td>
        <td>{{subject.composedMark}}</td>
        <td>{{subject.attempts}}</td>
        <td>{{subject.passed ? '+' : '-'}}</td>
      </tr>
      </table>
      </div>
    </b-jumbotron>
  </div>
</template>

<script>
import { AXIOS } from "./http-common";

export default {
  name: "Student",
  data() {
    return {
      student: { name: "??", department: "??", subjects: [], group: "??" },
      alertMessage: "Request error",
      hasError: false
    };
  },
  mounted() {
    this.loadItems(
      this.$route.params.groupName,
      this.$route.params.studentName
    );
  },
  beforeRouteUpdate(to, _, next) {
    this.loadItems(to.params.groupName, to.params.studentName);
    next();
  },
  methods: {
    showAlert() {
      this.dismissCountDown = this.dismissSecs;
    },
    async loadItems(groupName, studentName) {
      let res = await AXIOS.get("/edu/groups/" + groupName, {})
        .then(
          response => {
            console.log(response);
            var target = null;
            response.data.students.forEach(student => {
              if ((student.name + ' ' + student.surname) === studentName) {
                target = {
                  name: student.name,
                  group: response.data.name,
                  department: response.data.department,
                  marks: student.marks
                };
              }
            });
            if (target === null) {
              this.student = {
                name: "??",
                department: "??",
                marks: [],
                group: "??"
              };
              this.$data.alertMessage = `404: Student ${studentName} is not in group ${groupName}`;
              this.hasError = true;
            } else {
              target.subjects = [];
              for (let subject in target.marks) {
                let subj = {
                  name: target.marks[subject].subject.name,
                  year: target.marks[subject].subject.year,
                  month: target.marks[subject].subject.month,
                  hasExam: target.marks[subject].subject.hasExam,
                  composedMark: target.marks[subject].composedMark,
                  attempts: target.marks[subject].attempts,
                  passed:
                    target.marks[subject].composedMark >= 60 &&
                    target.marks[subject].attempts > 0
                };
                target.subjects.push(subj);
              }
              this.student = target;
              this.hasError = false;
            }
            return this.student;
          },
          error => {
            this.$data.alertMessage =
              error.response.data.length < 150
                ? error.response.data
                : "Request error. Please, report this error website owners";
            this.hasError = true;
            this.student = {
              name: "??",
              department: "??",
              marks: [],
              group: "??"
            };
            console.log(error);
          }
        )
        .catch(e => {
          console.log(e);
          this.showAlert(
            "Server error. Please, report this error website owners"
          );
          this.student = {
            name: "??",
            department: "??",
            marks: [],
            group: "??"
          };
          this.hasError = true;
        });
      console.log(res);
    }
  }
};
</script>

<style>
.mydiv-tablealign{
	text-align:center
}
</style>